﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Text;


using Prox_ESC_POS_Printer;
using LibUsbDotNet;
using LibUsbDotNet.LibUsb;
using LibUsbDotNet.Main;
using LibUsbDotNet.Descriptors;
using System.IO.Ports;
using System.IO;

namespace Example
{
    public partial class Form1 : Form
    {
        int Com_Anount;
        int Usb_Amount;

        /// USB list 變數
        /// 
        private UsbRegDeviceList Usb_Device_List= UsbGlobals.AllDevices;

        public Form1()
        {
            InitializeComponent();

            //string k = Local_Device.SerialPortList[0];



            ///
            /// 取得USB list 與 com list
            /// 
            Usb_Device_List = UsbGlobals.AllDevices;
            string[] ports = SerialPort.GetPortNames();
            Com_Anount = ports.Length;
            Usb_Amount = Usb_Device_List.Count;
            foreach (string s in ports)
            {
                comboBox1.Items.Add(s);
            }

            foreach (UsbRegistry device in Usb_Device_List)
            {
                string sAdd = string.Format("Vid:0x{0:X4} Pid:0x{1:X4} (rev:{2}) - {3}",
                                            device.Vid,
                                            device.Pid,
                                            (ushort)device.Rev,
                                            device[SPDRP.DeviceDesc]);
                comboBox1.Items.Add(sAdd);

            }

            //取得Barcode列印方式
            for (int i = 0; i < 7; i++)
            {
                Barcode_System Barcode=(Barcode_System)Enum.Parse(typeof(Barcode_System), Convert.ToString(i));
                comboBox2.Items.Add(Barcode.ToString());
            }

            if (comboBox1.Items.Count == 0)
            {
                comboBox1.Items.Add("No USB or Serial devices found.");
            }



           
        }

        ///

        //private SerialPort 

        /// <summary>
        /// 將要開啟的USB 指定給Printer_Device的UsbPort1Registry並開啟與初始化
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        Printer_Device Local_Device;
        UsbRegistry UsbPort1Registry;
        private void button1_Click(object sender, EventArgs e)
        {

            //USB Port use
            if (comboBox1.SelectedIndex >= Com_Anount)
            {

                Usb_Amount = comboBox1.Items.Count - Com_Anount;
                Local_Device = new Printer_Device(Usb_Device_List[comboBox1.SelectedIndex - Com_Anount]);
                Local_Device.Usb_Port_Open();

                //註冊Automatic_Status_Back事件
               Local_Device.Printer_Event.Automatic_Status_Back += new Printer_Event.String_Hander(Printer_Event_Automatic_Status_Back);
            }
            else
            {
                SerialPort s = new SerialPort(comboBox1.Text, 115200, System.IO.Ports.Parity.None);
                Local_Device = new Printer_Device(s);
                Local_Device.Serial_Port_Open();
                //Local_Device.Printer_Event.Automatic_Status_Back += new Printer_Event.String_Hander(Printer_Event_Automatic_Status_Back);
            }
        }

        /// <summary>
        /// 委派型別
        /// </summary>
        /// <param name="s"></param>
        public delegate void Get_String(string s);

        ///事件委派涵式
        void Printer_Event_Automatic_Status_Back(object s, Printer_Receive e)
        {
            ///取得事件文字
            ///非同步取得
            Get_String mi = new Get_String(this.UpdateUI);
            this.BeginInvoke(mi, e.Get_string);
        }

        private void UpdateUI(string s)
        {
            ///
            char[] k = s.ToCharArray();
            for (int i = 0; i < k.Length; i++)
            {

                richTextBox2.Text += Convert.ToInt16(k[i])+" ";
            }
            richTextBox2.Text += "||";
        }


        private void button2_Click(object sender, EventArgs e)
        {

            /////
            ///// 設定文字狀態
            ///// 
             
            // Printer_String_Status String_Status = new  Printer_String_Status();

            /////密度 60-140
            //String_Status.Density = 100;

            /////左邊起始位置
            //String_Status.Left_Margin_Set = 0;

            /////字與字之間空格
            //String_Status.Space = 0;

            /////上下兩行間空格
            //String_Status.Up_Down_Dots = 10;

            /////粗體
            //String_Status.Bold = true;

            /////翻轉
            //String_Status.Flip = false;

            /////底線
            //String_Status.Underline = true;

            /////反白
            //String_Status.Reverse = false;

            /////旋轉
            //String_Status.Rotate = false;

            /////字型大小設定 x y 0-7
            //String_Status.String_Set.X = 0;
            //String_Status.String_Set.Y = 0;

            /////置中對齊
            //String_Status.String_Alignment.Centered = true;


            ///列印文字
            //Local_Device.Printer_String.Printer_String_Print(String_Status, richTextBox1.Text);
            Local_Device.Printer_String.Printer_String_Print(richTextBox1.Text);

            //Font font=new Font("新細明體", 9);

            /////前進10dot
            //Local_Device.Printer_Auxiliary.Printer_Print_and_Feed_Forward(10);

            /////列印特殊文字
            //Local_Device.Printer_String.Printer_Special_String_Print(String_Status, font, "南京資訊股份有限公司");
        }

        Bitmap picimg3;

        private void button4_Click(object sender, EventArgs e)
        {
             
             OpenFileDialog openFileDialog1 = new OpenFileDialog();
             if (openFileDialog1.ShowDialog() == DialogResult.OK)
             {
                 try
                 {
                     string k = openFileDialog1.FileName;
                     picimg3 = (Bitmap)Bitmap.FromFile(k);

                     MemoryStream ms = new MemoryStream();
                     picimg3.Save(ms, System.Drawing.Imaging.ImageFormat.Png);
                     System.Drawing.Bitmap x = new Bitmap(picimg3, pictureBox1.Width, pictureBox1.Height);
                     pictureBox1.Image = x;

                     ///上傳圖片至暫存區準備列印
                     Local_Device.Printer_Image.Printer_Upload_Image(picimg3);
                 }
                 catch (ApplicationException ex)
                 {
                     MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                 }
             }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            /////圖片狀態設定
            //Printer_Image_Status Image_Status = new  Printer_Image_Status();          
            //Image_Status.Image_Position.Normal_Mode_Printing = true;
            //Image_Status.Image_Position.Left_Space = 10;

            /////列印暫存圖片
            ////Local_Device.Printer_Image.Printer_Image_Print(Image_Status);
            Local_Device.Printer_Image.Printer_Image_Print();
            //////讀取圖片檔案
            ////Bitmap[] v = new Bitmap[4];
            ////v[0] = (Bitmap)Bitmap.FromFile(@"C:\\Documents and Settings\\Administrator\\Desktop\\20091211 - ECR_POS\\printer test\\printer test\\bcaza2\\1.bmp");


            ///////上傳圖片陣列至非易失性記憶體
            ////Local_Device.Printer_Image.Printer_Upload_NV_Image(v);

            // Printer_Image_Status ImageStatus = new  Printer_Image_Status();

            ///////選擇列印圖片index
            //ImageStatus.Image_Position.Select = 2;
            //ImageStatus.Image_Position.Left_Space = 10;
            //Local_Device.Printer_Image.Printer_NV_Image_Print(ImageStatus);

            ///////指定左邊開始列印位置
            //ImageStatus.Image_Position.Left_Space = 10;
            //Local_Device.Printer_Image.Printer_NV_Image_Print(ImageStatus);

            //ImageStatus.Image_Position.Select = 1;

            ///////指定列印大小
            //ImageStatus.Image_Position.Double_Width_Mode_Printing = true;
            //ImageStatus.Image_Position.Left_Space = 15;
            //Local_Device.Printer_Image.Printer_NV_Image_Print(ImageStatus);

            ///////圖片密度
            //ImageStatus.Density = 60;
            //ImageStatus.Image_Position.Select = 0;
            //Local_Device.Printer_Image.Printer_NV_Image_Print(ImageStatus);
        }

        
        private void button5_Click(object sender, EventArgs e)
        {
            ///前進
            Local_Device.Printer_Auxiliary.Printer_Print_and_Feed_Forward(100);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            ///剪紙
            Local_Device.Printer_Auxiliary.Printer_Paper_Cut();
            
        }

        private void button7_Click(object sender, EventArgs e)
        {
            ///印表機初使化
            Local_Device.Printer_Auxiliary.Printer_Initialize();
        }

        private void button8_Click(object sender, EventArgs e)
        {
            ///列印測試頁
            Local_Device.Printer_Auxiliary.Printer_Test_Print();
        }

        private void button9_Click(object sender, EventArgs e)
        {
            ///Function set
            Local_Device.Printer_Auxiliary.Printer_Function_Settings();
        }

        private void button10_Click(object sender, EventArgs e)
        {
            ///清除非易失性記憶體
            Local_Device.Printer_Auxiliary.Printer_Extension_Memory_Initialize();
        }

        private void button11_Click(object sender, EventArgs e)
        {
            

        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void button12_Click(object sender, EventArgs e)
        {
            Printer_Barcode_Status BarcodeStatus = new Printer_Barcode_Status();
            //設定barcode長度
            BarcodeStatus.Barcode_Height_Set = 80;

            //設定barcode寬度(2~6)
            BarcodeStatus.Barcode_Horizontal_Size_Set = 2;

            BarcodeStatus.Alignment = Barcode_Alignment.Left;
            BarcodeStatus.Barcode_Style =(Barcode_System)comboBox2.SelectedIndex ;
            BarcodeStatus.Position =Character_Position.Over_And_Under_Barcode;

            Local_Device.Printer_Barcode.Barcode_Status.Position = Character_Position.Do_Not_Print;
            

            //列印barcode
            if(textBox1.Text!="" && comboBox2.SelectedItem!=null )
            {
                Local_Device.Printer_Barcode.Printer_Barcode_Print(textBox1.Text);
                //Local_Device.Printer_Barcode.Printer_Barcode_Print(BarcodeStatus, textBox1.Text);
            }
        }

        private void button13_Click(object sender, EventArgs e)
        {
            Local_Device.Printer_Auxiliary.Printer_Specification_Pulse();
        }

        

 





    }
}
